//+------------------------------------------------------------------+
//|                                                     SETMOCHA.mq4 |
//|                                Kirill,   www.FX4U.ru |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Kirill"
#property link      "StockProgrammer@mail.ru"

/*
    :
   .
 . ( 1)
 13.3.3.  20/80.

     2.
 1.
  .
       0-20. ,   .
     .
 2.
  .
      20/80.
  buy.
     .
 3.
  .
   ,    .
        .
       , ..  .
 4.
  .
      20/80.
  buy
     .
 5.
  .
     ,    .
        .
       .
       .

      .

 6.
  .
       80-100.
   .
,   .
     .

  .    20/80    
 .

        3.

    .
.
. .
.
 .
.
*/

//v2.5 = v2.2 + CheckLastSignal();

#define        ZONELOW    1
#define        ZONEMID    2
#define        ZONEHIG    3

#define        UP         1
#define        DW         -1

extern int     Magic          = 1110;
extern int     StopLoss       = 70;
extern double  Lots           = 0.1;
extern bool    Dolivka        = false;
extern string  Comment1       = " "; 
extern int     StochK         = 15;
extern int     StochD         = 15;
extern int     StochSlow      = 15;
extern int     StochMA_Method = 0;
extern double  LVLHIGH        = 80;
extern double  LVLLOW         = 20;
extern string  comment2       =  " MA ";
extern bool    UseMAFilter    =  true;
extern int     w              =  10;
extern double  a              =  0.01;


int      slip  = 3;
datetime BARflag  = 0;           //  

double   Smain =  0.0;  //       . .     .
double   Ssign =  0.0;  //     . .     .

int   tArray[100];
int   T     = 0;
int   DIR   = 0;
int   LastSignal = -1;

string         CommentArray[7];

int init()
{
   CommentArray[0] = "SETMOCHA v3.0" + "\n" + "  www.FX4U.ru";
 
     
   return(0);  
}

int deinit()
{
   
   return(0);
}

int start()
{
   int zone;
   int cross;

   datetime now = Time[0];
   if(BARflag < now)             // 
   {
      BARflag = now;
      
      CommentArray[1] = TimeToStr(now);
      CommentArray[2] = "T = " + DoubleToStr(T,0);
   
      CountStoch();  //    . 
      zone = ZoneCurr();
      cross = Crossed(Smain, Ssign);
      if(cross != 0)
      {
         CheckOrders(); //  ,    tArray[]
         switch(zone)   //  - ,    .   .
         {
            case ZONELOW:  CommentArray[3] = "In ZONELOW";
                           ZoneLow(cross);
                           break;
            case ZONEMID:  CommentArray[3] = "In ZONEMID";
                           ZoneMid(cross);
                           break;
            case ZONEHIG:  CommentArray[3] = "In ZONEHIG";
                           ZoneHig(cross);
                           break;                        
         }
      }
      else
      {
         string lscomm;
         switch(LastSignal)
         {
            case -1: lscomm = "NONE";
                     break;
            case 0:  lscomm = "OP_BUY";
                     break;
            case 1:  lscomm = "OP_SELL";
                     break;                     
         }
         CommentArray[3] = "NO CROSS --- Checking Last Signal = " + lscomm; 
         CheckLastSignal();
      }
      

      PrintComment();
      NullComment();
      
           
   }   
        
   return(0);
}

//--------------------------------------------STOCH--------------------------------------------
void CountStoch()
{
   Smain = iStochastic(NULL, 0, StochK, StochD, StochSlow, StochMA_Method, 0, MODE_MAIN,   1);
   Ssign = iStochastic(NULL, 0, StochK, StochD, StochSlow, StochMA_Method, 0, MODE_SIGNAL, 1);
}

int Crossed(double line1, double line2)  //return: UP = up, DW = down, 0 = no cross
{
   static int last_direction = 0;
   static int current_direction = 0;

   if(line1>line2)current_direction = UP;  //up
   if(line1<line2)current_direction = DW;  //down

   if(current_direction != last_direction) //changed
   {
      last_direction = current_direction;
      return (last_direction);
   }

   else
   {
      return (0);
   }

}

//---------------------------------------------CHK---------------------------------------------
void CheckOrders() //     !     !          <<<< ! <<<<
{
   if(tArray[0] > 0)   
   {
      if(OrderSelect(tArray[0], SELECT_BY_TICKET))
      {
         if(OrderCloseTime()!=0)
         {   
            T = 0; DIR = 0;
         }
      }
   }
   
   else
      T = 0;
}

void CloseT()
{
   int i;
   bool res;
   
   if(DIR == UP)
   {
      for(i=0; i<T; i++)
      {
         OrderSelect(tArray[i], SELECT_BY_TICKET);
         SemaphoreTake("TRADECONTEXT");
         res = OrderClose(OrderTicket(), OrderLots(), Bid, slip, White);
         SemaphoreReturn("TRADECONTEXT");
         if(res == false) {Alert("OrderClose Error:", GetLastError());}
      }
   }

   if(DIR == DW)
   {
      for(i=0; i<T; i++)
      {
         OrderSelect(tArray[i], SELECT_BY_TICKET);
         SemaphoreTake("TRADECONTEXT");
         res = OrderClose(OrderTicket(), OrderLots(), Ask, slip, White);
         SemaphoreReturn("TRADECONTEXT");     
         if(res == false) {Alert("OrderClose Error:", GetLastError());}
      }
   }
   
   T = 0; DIR = 0;
   
}

//--------------------------------------------ZONES--------------------------------------------
int ZoneCurr()
{
   if(Smain < LVLLOW)
      return(ZONELOW);
   else if(Smain > LVLHIGH)
      return(ZONEHIG);
   else
      return(ZONEMID);
}

void ZoneLow(int cross)
{
   //       
   if(cross == DW)   
      return(0);
   
   // 
   if(T!=0 && DIR == DW)
   CloseT();
   
   //  
   if(T==0)
   {
      double ma   =  iCustom(NULL, 0, "adaptivsMEMA", w, a, 0);
      if(UseMAFilter == false || Bid > ma)                                       //MA Filter
      {
         SemaphoreTake("TRADECONTEXT");
         tArray[0] = OrderSend(Symbol(), OP_BUY, Lots, Ask, slip, Bid - StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
         SemaphoreReturn("TRADECONTEXT");
         if(tArray[0]<0) {Alert("OrderSend Error: ", GetLastError()); return(0);}
      
         DIR = UP;
         T++;
         
         LastSignal = -1;
      }
      else
      {
         LastSignal = OP_BUY;
         CommentArray[4] = "MA Filter: NOT PASSED --- BUY Signal Remembered";
      }   
   }
}

void ZoneHig(int cross)
{
   //       
   if(cross == UP)   
      return(0);
   
   // 
   if(T!=0 && DIR == UP)
   CloseT();
   
   //  
   if(T==0)
   {
      double ma   =  iCustom(NULL, 0, "adaptivsMEMA", w, a, 0);
      if(UseMAFilter == false || Bid < ma)                                       //MA Filter
      {
         SemaphoreTake("TRADECONTEXT");
         tArray[0] = OrderSend(Symbol(), OP_SELL, Lots, Bid, slip, Ask + StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
         SemaphoreReturn("TRADECONTEXT");
         if(tArray[0]<0) {Alert("OrderSend Error: ", GetLastError()); return(0);}
      
         DIR = DW;
         T++;
         
         LastSignal = -1;
      }   
      else
      {
         LastSignal = OP_SELL;
         CommentArray[4] = "MA Filter: NOT PASSED --- SELL Signal Remembered";
      }        
   }
}

void ZoneMid(int cross)
{
   int i, res;
   double bid = Bid, ask = Ask;
   double ma =  iCustom(NULL, 0, "adaptivsMEMA", w, a, 0);
   
   //     ,     
   if(T == 0)
      return(0);
   
   //   +  
   if(cross == UP && DIR == UP)
   {
      if(Dolivka == true)
      {
         if(UseMAFilter == false || Bid > ma)                                       //MA Filter
         {   
            SemaphoreTake("TRADECONTEXT");
            tArray[T] = OrderSend(Symbol(), OP_BUY, Lots, ask, slip, bid - StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
            SemaphoreReturn("TRADECONTEXT");
            if(tArray[T]<0) {Alert("OrderSend Error: ", GetLastError());}
            T++;
         }
         else
         {
            CommentArray[4] = "MA Filter: NOT PASSED";
         }  
      }
      else          
      {
         CommentArray[4] = "Dolivka = false";
      }  
      
      for(i=0; i<T-1; i++)
      {
         SemaphoreTake("TRADECONTEXT");
         res = OrderModify(tArray[i], 0, bid - StopLoss*Point, 0, 0);
         SemaphoreReturn("TRADECONTEXT");
         if(res < 0) {Alert("Ticket #", tArray[i], " OrderModify Error: ", GetLastError());}
      }
   }
   
   //   +  
   if(cross == DW && DIR == DW)
   {
      if(Dolivka == true)
      {   
         if(UseMAFilter == false || Bid < ma)                                       //MA Filter
         {   
            SemaphoreTake("TRADECONTEXT");
            tArray[T] = OrderSend(Symbol(), OP_SELL, Lots, bid, slip, ask + StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
            SemaphoreReturn("TRADECONTEXT");
            if(tArray[T]<0) {Alert("OrderSend Error: ", GetLastError());}
            T++;
         }
         else
         {
            CommentArray[4] = "MA Filter: NOT PASSED";
         }        
      }
      else          
      {
         CommentArray[4] = "Dolivka = false";
      }  
            
      for(i=0; i<T-1; i++)
      {
         SemaphoreTake("TRADECONTEXT");
         res = OrderModify(tArray[i], 0, ask + StopLoss*Point, 0, 0);
         SemaphoreReturn("TRADECONTEXT");
         if(res < 0) {Alert("Ticket #", tArray[i], " OrderModify Error: ", GetLastError());}
      }
   }   
}


void CheckLastSignal()
{
   double ma   =  iCustom(NULL, 0, "adaptivsMEMA", w, a, 0);

//---------BUY---------
   if(LastSignal == OP_BUY)
   {
      if(Bid > ma)                                       //MA Filter
      {
         SemaphoreTake("TRADECONTEXT");
         tArray[0] = OrderSend(Symbol(), OP_BUY, Lots, Ask, slip, Bid - StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
         SemaphoreReturn("TRADECONTEXT");
         if(tArray[0]<0) {Alert("OrderSend Error: ", GetLastError()); return(0);}

         DIR = UP;
         T++;
   
         LastSignal = -1;                                                        // 
      }
      else
      {
         LastSignal = OP_BUY;
         CommentArray[4] = "MA Filter: NOT PASSED AGAIN --- BUY Signal Remembered Still";
      }   
   }   
//---------SELL---------
   else if(LastSignal == OP_SELL)
   {
      if(Bid < ma)                                       //MA Filter
      {
         SemaphoreTake("TRADECONTEXT");
         tArray[0] = OrderSend(Symbol(), OP_SELL, Lots, Bid, slip, Ask + StopLoss*Point, 0, "SETMOCHA #" + DoubleToStr(Magic,0) + ": NUMBER IN GROUP = " + DoubleToStr(T+1, 0), Magic);
         SemaphoreReturn("TRADECONTEXT");
         if(tArray[0]<0) {Alert("OrderSend Error: ", GetLastError()); return(0);}

         DIR = DW;
         T++;
   
         LastSignal = -1;                                                        // 
      }   
      else
      {
         LastSignal = OP_SELL;
         CommentArray[4] = "MA Filter: NOT PASSED AGAIN --- SELL Signal Remembered Still";
      }        
   }
   
}

//------------------------------------------SEMAPHORE------------------------------------------

int critical = 0;

void SemaphoreTake(string SEM)
{ 
   if(GlobalVariableCheck(SEM) == false)
      GlobalVariableSet(SEM, 0);
  
   while(1==1)
   {
      if(GlobalVariableSetOnCondition(SEM, 1.0, 0.0))         // 
      {
         critical = 1;
         Print("SEMAPHORE \"", SEM, "\" TAKEN. CURRENT VALUE: ", GlobalVariableGet(SEM));
         break;      //    
      }
      else
      {
         Print("ATTEMPT TO CAPTURE SEMAPHORE \"", SEM, "\" FAILED. SEMAPHORE BUSY. WAITING 0.1 SEC. CURRENT VALUE: ", GlobalVariableGet(SEM));
         Sleep(100);
      }
   }
} 

void SemaphoreReturn(string SEM)
{
   GlobalVariableSet(SEM, 0.0);
   Print("SEMAPHORE \"", SEM, "\" RETURNED. CURRENT VALUE: ", GlobalVariableGet(SEM));
   critical = 0;
}



//------------------------------------------PrintComment------------------------------------------

void PrintComment()
{
   Comment(CommentArray[0], "\n",
           CommentArray[1], "\n",
           CommentArray[2], "\n",
           CommentArray[3], "\n",
           CommentArray[4], "\n",
           CommentArray[5], "\n",
           CommentArray[6], "\n");
}

void NullComment()
{
   for(int i=1; i<7 && i!=5; i++)
      CommentArray[i] = "";
}


